/* Estrela-de-Fogo. Usa vetores com FOR. */


#include <graphics.h>
#include <conio.h>                   // necessario para getch ()
#include <math.h>                    // M_PI, cos, sin, ...


/* Retorna a parte fracionaria de um numero do tipo DOUBLE.
****************************************************************************/
inline double Frac ( double Numero )
{
	long
		NInteiro = ( long ) Numero;

	return ( (double) Numero - NInteiro );
}


void Vetor ( int Angulo, int Comprimento )
{
	static int
		SomaAngs = 0;

	SomaAngs = ( SomaAngs + Angulo ) % 360;

	double
		Radianos = (double) ( SomaAngs * (double) ( M_PI / 180 ) ),
		Base = (double) ( cos ( Radianos ) * Comprimento + (double) Frac ( Base ) ),
		Altura = (double) ( - sin ( Radianos ) * Comprimento + (double) Frac ( Altura ) );

	linerel ( (int) Base, (int) Altura );
}


/* Desenha estrela.
****************************************************************************/
void Faz_Estrela_de_Fogo ()
{
	moveto ( getmaxx () / 2, getmaxy () /2 );

	for (int Conta1 = 1; Conta1 <= 1800; Conta1 += 10)
		for (int Conta2 = Conta1 + 1; Conta2 <= 360 + Conta1; Conta2 += 10)
			for (int Conta3 = Conta2 + 1; Conta3 <= 360 + Conta2; Conta3 += 100)
				Vetor (Conta3 + 180, 5);
}


main ()
{
	int
		GrDriver = DETECT,
		GrMode;

	initgraph (&GrDriver, &GrMode, "");

	Faz_Estrela_de_Fogo ();

	getch ();
	closegraph ();
}